<template>
  <v-card class="mx-auto overflow-hidden contenedor">
    <v-app-bar
      class="nav-deg"
      dark
      flat
    >
      <v-app-bar-nav-icon @click.stop="drawer = !drawer"></v-app-bar-nav-icon>
      <v-toolbar-title>SECAP</v-toolbar-title>
      <v-spacer></v-spacer>
      <div v-if="loggedIn==false">
        <v-btn @click="dialog = !dialog" class="ma-2" outlined color="white">Iniciar sesión</v-btn>
      </div>
      <div v-if="loggedIn==true">
        <v-btn  @click="confirmSignOut = !confirmSignOut" class="ma-2" outlined color="white">Cerrar sesión</v-btn>
      </div>
    </v-app-bar>
    <v-navigation-drawer
        class="nav-deg"
        dark
        v-model="drawer"
        absolute
        temporary
      >
      <v-list dense>
        <v-list-item
          v-for="nav_item in nav_items"
          :key="nav_item.title"
          link
        >
          <v-list-item-icon @click="changeview(nav_item.value)">
            <v-icon>mdi-{{ nav_item.icon }}</v-icon>
          </v-list-item-icon>
          <v-list-item-content @click="changeview(nav_item.value)">
            <v-list-item-title>{{ nav_item.title }}</v-list-item-title>
          </v-list-item-content>
        </v-list-item>
        <v-list-item v-if="loggedIn==true" link>
          <v-list-item-icon @click="changeview(2)">
            <v-icon>mdi-order-bool-ascending-variant</v-icon>
          </v-list-item-icon>
          <v-list-item-content @click="changeview(2)">
            <v-list-item-title>Pedidos</v-list-item-title>
          </v-list-item-content>
        </v-list-item>
      </v-list>
    </v-navigation-drawer>
    <v-dialog v-model="dialog" max-width="500px">
      <div class="contenedor-login">
      <v-img src="../assets/mercadito.png" aspect-ratio="1.0" class="imagen-login"></v-img>
      <v-card>
        <v-card-title>
          <span class="headline">Inicio de sesion</span>
        </v-card-title>
        <v-card-text>
          <v-text-field type="text" placeholder="Ingresar correo" v-model="email">
          </v-text-field>
          <v-text-field type="password" placeholder="Ingresar contraseña" v-model="password">
          </v-text-field>
          <v-img src="../assets/logoEscucha.png" aspect-ratio="3.0" class="logo-escucha"></v-img>
          <div>¿No tienes cuenta?
            <v-btn text small color="blue"  @click="dialog = !dialog, dialog2 = !dialog2">
              Registrate
            </v-btn>
          </div>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn dark color="red" @click="dialog = !dialog, clearFields()">Cancelar</v-btn>
          <v-btn dark color="#8CC63F" @click.prevent="logIn">Acceder</v-btn>
        </v-card-actions>
      </v-card>
      </div>
    </v-dialog>
    <v-dialog v-model="dialog2" max-width="500px">
      <v-card>
        <v-card-title>
          <span class="headline">Registro de usuarios</span>
        </v-card-title>
        <v-card-text>
          <v-text-field
          v-for="user in user_data"
          :key="user.title" type="text" :placeholder="user.title" v-model="user.value">
          </v-text-field>
          <v-text-field type="password" v-model="user_password" placeholder="Contraseña" :rules="[
                  () => !!user_password ||'Este campo es requerido',
                  () => !!user_password && user_password.length <= 25 || 'Tus contraseña excede el limite de caracteres',
                  () => !!user_password && user_password.length >= 6 || 'Tus contraseña es menor a 8 caracteres']">
          </v-text-field>
          
        </v-card-text>
        
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn dark color="red" @click="dialog2 = !dialog2, clearFields()">Cancelar</v-btn>
          <v-btn dark color="#8CC63F" @click.prevent="signUp(), dialog2 = !dialog2">Acceder</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="confirmSignOut" max-width="500px">
      <v-card>
        <v-card-title>
          <span class="headline">¿Estas seguro de cerrar sesión?</span>
        </v-card-title>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn dark color="red" @click="confirmSignOut = !confirmSignOut">Cancelar</v-btn>
          <v-btn dark color="#8CC63F" @click.prevent="signOut(), confirmSignOut = !confirmSignOut">Aceptar</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <div v-if="view==0">
        <ListaProductos :loggedIn="loggedIn" :lastPurchase="lastPurchase" @toOrder="changeview"/>
    </div>
    <div v-if="view==1">
        <ListaPaquetes :loggedIn="loggedIn" :lastPurchase="lastPurchase" @toOrder="changeview"/>
    </div>
    <div v-if="view==2">
      <PedidosCliente :loggedIn="loggedIn" :lastPurchase="lastPurchase"/>
    </div>
  </v-card>
</template>

<script>
import "firebase/auth";
import * as firebase from "firebase/app";
import 'firebase/firestore';
import ListaProductos from './ListaProductos';
import ListaPaquetes from './ListaPaquetes';
import PedidosCliente from './PedidosCliente';

  export default {
    created(){
      firebase.auth().onAuthStateChanged(async user =>{
        this.loggedIn = !! user
        if(this.loggedIn){
        const userData = await this.$axios.get(`http://${process.env.VUE_APP_API_URL}/api/users/${user.uid}`,)
        this.user = userData.data
        let one_day=1000*60*60*24;
        let last_purchase = new Date(this.user.last_purchase)
        let today = Date.now()
        this.lastPurchase = Math.round( (today - last_purchase)/ one_day)
        }
      })
    },
    components: {
        ListaPaquetes,
        ListaProductos,
        PedidosCliente,
    },
    data (){
      return {
        confirmSignOut: false,
        loggedIn: false,
        user:'',
        email:'',
        password:'',
        error:'',
        view: 0,
        lastPurchase:0,
        user_data: [
          { title: 'Nombre', value:null},
          { title: 'Apellidos', value:null},
          { title: 'Calle y Número', value:null},
          { title: 'Colonia', value:null},
          { title: 'Código Postal', value:null},
          { title: 'Celular', value:null},
          { title: 'Correo electrónico', value:null},
        ],
        user_password: null,
        dialog: false,
        dialog2: false,
        drawer: null,
        nav_items: [
          { title: 'Productos', icon: 'basket', value:"0" },
          { title: 'Paquetes', icon: 'package-variant-closed', value:"1" },
        ],
      };
    },
    
    methods:{
      clearFields(){
        this.password=null
        this.user_password=null
        this.user_data.forEach(field => {
          field.value=null
        });
      },
      async changeLastPurchase(){
        const user = await firebase.auth().currentUser
        const userData = await this.$axios.get(`http://${process.env.VUE_APP_API_URL}/api/users/${user.uid}`)
        this.user = userData.data
        let one_day=1000*60*60*24;
        let last_purchase = new Date(this.user.last_purchase)
        let today = Date.now()
        this.lastPurchase = Math.round( (today - last_purchase)/ one_day)
      },
      changeview(value){
          this.view=value
          this.drawer=false
          this.changeLastPurchase()
      },
      async logIn(){
        firebase.auth().signInWithEmailAndPassword(this.email, this.password)
        .then(() => {
          this.dialog=false;
          this.clearFields()
        })
        .catch(error => {
          this.error = error
          })
      },
      async signUp(){
        let db = firebase.firestore()
        let email = this.user_data[6].value;
        let pass = this.user_password;
        var timestamp = firebase.firestore.Timestamp.fromDate(new Date(Date.UTC('2009','01','13','23','31','30')));
        let userData = {
          name: this.user_data[0].value,
          last_name: this.user_data[1].value,
          street:this.user_data[2].value,
          bloc: this.user_data[3].value,
          postal_code: this.user_data[4].value,
          phone:this.user_data[5].value,
          last_purchase: timestamp,
          email:email
        }
        firebase.auth().createUserWithEmailAndPassword(email, pass)
          .then(credentials =>{
            return db.collection('users').doc(credentials.user.uid).set(userData)
          }).then(() => {
            this.changeLastPurchase()
            this.clearFields()
            })

      },
      async signOut(){
        try {
          await firebase.auth().signOut();
        } catch (error) {
          console.log(error)
        }
      },
    },

  }
</script>
<style scoped>
.contenedor {
  background-color: #FAFAFA;
  height: 100%;
}
.nav-deg{
  background: linear-gradient(70deg, #572B53, #0B2748);
}
.dialog{
  background: linear-gradient(70deg, #572B53, #0B2748);
  height: 15rem;
}
.contenedor-login {
  background: linear-gradient(70deg, #572B53, #0B2748);
  height: 50%;
  margin: 1%;
}
.imagen-login{
  display:block;
  margin:auto;
  width:100%;
  max-width:200px;
}
.logo-escucha{
  display:block;
  margin:auto;
  width:100%;
  max-width:200px;
}
.boton-login{
  background-color: #414142;
  color: white;
}
</style>
